char *tcguirt = {
"if {[info procs cWidget] != \"\"} {\n"
"	return\n"
"}\n"
"proc set_tcgui {ix lst} {\n"
"	global tcgui\n"
"	foreach {name val} $lst {\n"
"		set tcgui($ix,$name) $val\n"
"	}\n"
"}\n"
"set_tcgui cmds { DISPLAY 1 WITHDRAW 2 SET-ATTR 3 INSERT-VALUE 4 \n"
"	SELECT-VALUE 5 WAIT 6}\n"
"set_tcgui events { ERROR 1 CLOSE 2 BUTTON 3 }\n"
"set_tcgui tkattb { 1 foreground 2 background 3 font 4 relief 5 border }\n"
"set tcgui(tcl_attribs) {foreground background font relief border}\n"
"set_tcgui attrib { \n"
"	Label { label foreground background font relief border}\n"
"	Entry { cobolvar cobsize foreground background font \n"
"		relief border }\n"
"	Group { label cobolvar cobsize foreground background \n"
"		font relief border }\n"
"	Image { cobolvar cobsize background relief border}\n"
"	ComboBox { cobolvar cobsize foreground background font \n"
"		relief border }\n"
"	Listbox { cobolvar cobsize foreground background font \n"
"		relief border }\n"
"	Button { label foreground background font relief border }\n"
"	Checkbutton { label cobolvar cobsize  \n"
"		onvalue offvalue foreground background font relief border}\n"
"	Radiobutton { label cobolvar cobsize selvalue foreground \n"
"		background font relief border }\n"
"	Text { cobolvar cobsize foreground background font \n"
"		relief border }\n"
"}\n"
"proc get_cobvars {} {\n"
"	global tc tcgui ready\n"
"	set appl [string tolower $tc(gui_name)]\n"
"	set wappl .$appl\n"
"	set tc(data_ptr,$appl) $tc(data_ptr)\n"
"	switch $tc(cmd) {\n"
"	1 {\n"
"		wm deiconify $wappl\n"
"		foreach {ix name} [array get tcgui cobolvar,$wappl.*] {\n"
"			if {$name != \"\"} {\n"
"				set w [lindex [split $ix ,] 1]\n"
"				set size $tcgui(cobsize,$w)\n"
"				getcobvar val $tcgui(coboffset,$w) $size\n"
"				switch [winfo class $w] {\n"
"				Entry {\n"
"					$w delete 0 end	\n"
"					$w insert end [string trimright $val]\n"
"				}\n"
"				Text {\n"
"					$w config -state normal\n"
"					$w delete 0.0 end	\n"
"					$w insert end [string trimright $val] center\n"
"					$w config -state disabled \n"
"				}\n"
"				Radiobutton {\n"
"					set varname $tcgui(cobolvar,$w)\n"
"					#set tc($appl,$varname) $tcgui(value,$w,selval)\n"
"					getcobvar tc($appl,$varname) $tcgui(coboffset,$w) 1\n"
"				}\n"
"				Checkbutton {\n"
"					set varname $tcgui(cobolvar,$w)\n"
"					getcobvar tc(check,$appl,$varname) $tcgui(coboffset,$w) 1\n"
"				}\n"
"				Image {\n"
"					if {[info exists tc(image,$w)]} {\n"
"						$tc(image,$app,$w) destroy\n"
"					}\n"
"					set tc(image,$appl,$w) [image create photo \\\n"
"						-file [string trimright $val]]\n"
"					$w.i config -image $tc(image,$appl,$w)\n"
"				}\n"
"				}\n"
"			}\n"
"		}\n"
"		next_taborder $wappl\n"
"	}\n"
"	2 {\n"
"		wm withdraw $wappl\n"
"	}\n"
"	3 {\n"
"		set wname [format %03d $tc(widget_sel)]\n"
"		set w $tc($wappl,$wname)\n"
"		set_attribs $w.w $tcgui(tkattb,$tc(attr_type)) $tc(attr_value) \n"
"	}\n"
"	4 {\n"
"		set wname [format %03d $tc(widget_sel)]\n"
"		foreach {ix name} [array get tcgui cobolvar,$wappl.*$wname*] {\n"
"			if {$name != \"\"} {\n"
"				set w [lindex [split $ix ,] 1]\n"
"				set size $tcgui(cobsize,$w)\n"
"				getcobvar val $tcgui(coboffset,$w) $size\n"
"				if {[winfo class $w] == \"ComboBox\"} {\n"
"					$w.btm.lbox insert end [string trimright $val]\n"
"				}\n"
"				if {[winfo class $w] == \"Listbox\"} {\n"
"					$w insert end $val\n"
"				}\n"
"			}\n"
"		}\n"
"		set tc(event) 0\n"
"	}\n"
"	5 {\n"
"		set wname [format %03d $tc(widget_sel)]\n"
"		foreach {ix name} [array get tcgui cobolvar,$wappl.*$wname*] {\n"
"			if {$name != \"\"} {\n"
"				set w [lindex [split $ix ,] 1]\n"
"				set size $tcgui(cobsize,$w)\n"
"				getcobvar val $tcgui(coboffset,$w) $size\n"
"				if {[winfo class $w] == \"ComboBox\"} {\n"
"					$w.e delete 0 end\n"
"					$w.e insert end [string trimright $val]\n"
"				}\n"
"			}\n"
"		}\n"
"		set tc(event) 0\n"
"	}\n"
"	6 {\n"
"		wm deiconify $wappl\n"
"		tkwait variable ready\n"
"	}\n"
"	}\n"
"}\n"
"proc send_results {appl} {\n"
"	global tc tcgui\n"
"	set appl [string tolower $appl]\n"
"	foreach {ix name} [array get tcgui cobolvar,.$appl.*] {\n"
"		if {$name != \"\"} {\n"
"			set w [lindex [split $ix ,] 1]\n"
"			set size $tcgui(cobsize,$w)\n"
"			set uval \"\"\n"
"			switch [winfo class $w] {\n"
"			Entry { set uval [$w get] }\n"
"			Text { set uval [$w get 0.0 end] }\n"
"		    Listbox { \n"
"					set ix [$w curselection]\n"
"					if {$ix != \"\"} {\n"
"						set uval [$w get $ix]\n"
"					}\n"
"				}\n"
"			ComboBox { set uval [$w.e get] }\n"
"			}\n"
"			if {$uval != \"\"} {\n"
"				set val [format \"%-$size.${size}s\" $uval]\n"
"				setcobvar $val $tcgui(coboffset,$w) $size $tc(data_ptr)\n"
"			}\n"
"		}\n"
"	}\n"
"	# set variables modified by radiobuttons\n"
"	foreach {ix val} [array get tc $appl,*] {\n"
"		set varname [lindex [split $ix ,] 1]\n"
"		set val [string index $tc($ix) 0]\n"
"		setcobvar $val $tc(offset,$ix) 1 $tc(data_ptr)\n"
"	}\n"
"	# set variables modified by checkbuttons\n"
"	foreach {ix val} [array get tc check,$appl,*] {\n"
"		set varname [lindex [split $ix ,] 2]\n"
"		set ix1 [join [lrange [split $ix ,] 1 end] ,]\n"
"		setcobvar $tc($ix) $tc(offset,$ix1) 1 $tc(data_ptr)\n"
"	}\n"
"}\n"
"proc butevent {ev appl} {\n"
"	global tc ready\n"
"	set appl [string tolower $appl]\n"
"	set tc(gui_name) $appl\n"
"	set tc(data_ptr) $tc(data_ptr,$appl)\n"
"	send_results $appl\n"
"	set tc(event) $ev\n"
"	set ready 1\n"
"}\n"
"proc set_mainwin {appl width height} {\n"
"	global tcgui mainwin\n"
"	set w .[string tolower $appl]\n"
"	set mainwin [toplevel $w -width $width -height $height]\n"
"	wm withdraw $w \n"
"	set tcgui(usr_ev) 10\n"
"	set tcgui(appl) $appl\n"
"}\n"
"wm withdraw .\n"
"bind all <Control-c> exit\n"
"bind all <Control-d> {after 100 set ready 1 ; break}\n"
"bind edit <Tab> {next_taborder %W ; break}\n"
"bind edit <Shift-Tab> {prev_taborder %W ; break}\n"
"proc set_taborder {args} {\n"
"	global tcgui tc\n"
"	set appl [string tolower $tcgui(appl)]\n"
"	set new {}\n"
"	foreach n $args {\n"
"		lappend new [lindex $tc(taborder,$appl) \\\n"
"			[lsearch -glob $tc(taborder,$appl) *$n*]]\n"
"	}\n"
"	set tc(taborder,$appl) $new\n"
"}\n"
"proc prev_taborder {w} {\n"
"	global tc tcgui\n"
"	set appl [lindex [split $w .] 1]\n"
"	set tb $tc(taborder,$appl)\n"
"	set n [lsearch $tb $w]\n"
"	if {$n > 0} {\n"
"		incr n -1\n"
"	} else {\n"
"		set n [expr [llength $tb]-1]\n"
"	}\n"
"	if {$n < 0} {\n"
"		focus [lindex $tb end]\n"
"	} else {\n"
"		focus [lindex $tb $n]\n"
"	}\n"
"}\n"
"proc next_taborder {w} {\n"
"	global tc tcgui\n"
"	set appl [lindex [split $w .] 1]\n"
"	set tb $tc(taborder,$appl)\n"
"	set n [lsearch $tb $w]\n"
"	if {$n >= 0} {\n"
"		incr n\n"
"	} else {\n"
"		set n 0\n"
"	}\n"
"	if {$n < [llength $tb]} {\n"
"		focus [lindex $tb $n]\n"
"	} else {\n"
"		focus [lindex $tb 0]\n"
"	}\n"
"}\n"
"proc cWidget { type name parent x y wd ht var size offset args } {\n"
"	global tcgui mainwin tc \n"
"	if {$parent == \".\"} {\n"
"		set parent $mainwin \n"
"	} else {\n"
"		set parent $mainwin$parent\n"
"	}\n"
"	set appl [string tolower $tcgui(appl)]\n"
"	if {![info exists tcgui(taborder,$appl)]} {\n"
"		set tcgui(taborder,$appl) {}\n"
"	}\n"
"	set w [frame [join [list $parent $name] .]]\n"
"	if {$wd} {\n"
"		$w config -width $wd\n"
"	}\n"
"	if {$ht} {\n"
"		$w config -height $ht\n"
"	}\n"
"	switch $type {\n"
"	cLabel { \n"
"			set ww [label $w.w ]\n"
"		}\n"
"	cEntry {\n"
"			set ww [entry $w.w -width $size -textvariable tc($mainwin,$var)]\n"
"			lappend tc(taborder,$appl) $w.w\n"
"		}\n"
"	cList {\n"
"			scrollbar $w.sv -orient vertical -width 8 \\\n"
"				-border 1 -command [list $w.w yview] -takefocus 0\n"
"			scrollbar $w.sh -orient horizontal -width 8 \\\n"
"				-border 1 -command [list $w.w xview] -takefocus 0\n"
"			set ww [listbox $w.w -font {courier 12} -width $size \\\n"
"				-yscrollcommand [list $w.sv set] \\\n"
"				-xscrollcommand [list $w.sh set]]\n"
"			pack $w.sh -side bottom -fill x\n"
"			pack $w.sv -side right -fill y\n"
"			lappend tc(taborder,$appl) $w.w\n"
"		}\n"
"	cButton {\n"
"			set ww [button $w.w \\\n"
"				-command [list butevent [incr tcgui(usr_ev)] $tcgui(appl)]]\n"
"			lappend tc(taborder,$appl) $w.w\n"
"		}\n"
"	cCheck {\n"
"			set ww [checkbutton $w.w]\n"
"			lappend tc(taborder,$appl) $w.w\n"
"		}\n"
"	cRadio {\n"
"			set ww [radiobutton $w.w]\n"
"			lappend tc(taborder,$appl) $w.w\n"
"		}\n"
"	cGroup {\n"
"			set ww [frame $w.w -class Group]\n"
"			pack [frame $w.w.fr -bd 2 -relief groove -width 100 -height 100] \\\n"
"				-padx 10 -pady 10 -expand 1 -fill both\n"
"			place [label $w.w.lab] -in $w.w.fr -x 7 -y 0 -anchor w\n"
"			bindtags $w.w.fr [concat edit [bindtags $w.w.fr]]\n"
"		}\n"
"	cText { \n"
"			set ww [text $w.w -bg white \\\n"
"				-wrap word -state disabled]\n"
"			$w.w tag config center -justify center\n"
"		}\n"
"	cCombo { \n"
"			set ww [combobox $w.w ]\n"
"			bindtags $w.w.e [concat edit [bindtags $w.w.e]]\n"
"			bindtags $w.w.b [concat edit [bindtags $w.w.b]]\n"
"			lappend tc(taborder,$appl) $w.w.e\n"
"		}\n"
"	cImage { \n"
"			set ww [frame $w.w -class Image]\n"
"			pack [label $w.w.i] -expand 1 -fill both\n"
"		}\n"
"	}\n"
"	pack $ww -expand 1 -fill both\n"
"	place $w -x $x -y $y\n"
"	update\n"
"	set wid [winfo width $w]\n"
"	set hei [winfo height $w]\n"
"	pack propagate $w 0\n"
"	$w config -height $hei -width $wid\n"
"	bindtags $w.w [concat edit [bindtags $w.w]]\n"
"	if {$wd} {\n"
"		$w config -width $wd\n"
"	}\n"
"	if {$ht} {\n"
"		$w config -height $ht\n"
"	}\n"
"	set tcgui(cobolvar,$w.w) $var\n"
"	set tcgui(cobsize,$w.w) $size\n"
"	set tcgui(coboffset,$w.w) $offset\n"
"	set tc($mainwin,$name) $w\n"
"	eval set_attribs $w.w $args\n"
"	return $w	\n"
"}\n"
"proc cLabel {args} { 	eval cWidget cLabel $args }\n"
"proc cEntry {args} { 	eval cWidget cEntry $args }\n"
"proc cList {args} { 	eval cWidget cList $args }\n"
"proc cButton {args} { 	eval cWidget cButton $args }\n"
"proc cCheck {args} { 	eval cWidget cCheck $args }\n"
"proc cRadio {args} { 	eval cWidget cRadio $args }\n"
"proc cGroup {args} { 	eval cWidget cGroup $args }\n"
"proc cText {args} { 	eval cWidget cText $args }\n"
"proc cCombo {args} { 	eval cWidget cCombo $args }\n"
"proc cImage {args} { 	eval cWidget cImage $args }\n"
"proc apply_attrib {w} {\n"
"	global tcgui tc\n"
"	set class [winfo class $w]\n"
"	if {$class == \"Group\"} {\n"
"		foreach at $tcgui(attrib,$class) {\n"
"			if {[info exists tcgui(value,$w,$at)] &&\n"
"				$tcgui(value,$w,$at) != \"\" &&\n"
"				[lsearch $tcgui(tcl_attribs) $at]>=0} {\n"
"					$w.fr config -$at $tcgui(value,$w,$at)\n"
"					if {[lsearch {border relief} $at]<0} {\n"
"						$w.lab config -$at $tcgui(value,$w,$at)\n"
"					}\n"
"			} elseif {$at == \"label\" && \n"
"				[info exists tcgui(value,$w,label)]} {\n"
"			# special label attribute for buttons, groups and labels\n"
"					$w.lab config -text $tcgui(value,$w,$at)\n"
"			}\n"
"		}	\n"
"	} elseif {$class == \"ComboBox\"} {\n"
"		foreach at $tcgui(attrib,$class) {\n"
"			# standard tcl attributes\n"
"			if {[info exists tcgui(value,$w,$at)] &&\n"
"				$tcgui(value,$w,$at) != \"\" &&\n"
"				[lsearch $tcgui(tcl_attribs) $at]>=0} {\n"
"					$w.e config -$at $tcgui(value,$w,$at)\n"
"			} elseif {$at == \"label\" &&\n"
"				[info exists tcgui(value,$w,label)]} {\n"
"			# special label attribute for buttons, groups and labels\n"
"				$w.e config -text $tcgui(value,$w,$at)\n"
"			} \n"
"		}\n"
"	} elseif {$class == \"Radiobutton\"} {\n"
"		foreach at $tcgui(attrib,$class) {\n"
"			# standard tcl attributes\n"
"			if {[info exists tcgui(value,$w,$at)] &&\n"
"				$tcgui(value,$w,$at) != \"\" &&\n"
"				[lsearch $tcgui(tcl_attribs) $at]>=0} {\n"
"					$w config -$at $tcgui(value,$w,$at)\n"
"			} elseif {$at == \"label\" &&\n"
"				[info exists tcgui(value,$w,label)]} {\n"
"				$w config -text $tcgui(value,$w,$at)\n"
"			} elseif {$at == \"cobolvar\"} {\n"
"				set appl [string tolower $tc(gui_name)]\n"
"				set varname $tcgui(cobolvar,$w)\n"
"				$w config -variable tc($appl,$varname) \\\n"
"					-value $tcgui(value,$w,selval)\n"
"				set tc(offset,$appl,$varname) $tcgui(coboffset,$w)\n"
"			}\n"
"		}\n"
"	} elseif {$class == \"Checkbutton\"} {\n"
"		foreach at $tcgui(attrib,$class) {\n"
"			# standard tcl attributes\n"
"			if {[info exists tcgui(value,$w,$at)] &&\n"
"				$tcgui(value,$w,$at) != \"\" &&\n"
"				[lsearch $tcgui(tcl_attribs) $at]>=0} {\n"
"					$w config -$at $tcgui(value,$w,$at)\n"
"			} elseif {$at == \"label\" &&\n"
"				[info exists tcgui(value,$w,label)]} {\n"
"				$w config -text $tcgui(value,$w,$at)\n"
"			} elseif {$at == \"cobolvar\"} {\n"
"				set appl [string tolower $tc(gui_name)]\n"
"				set varname $tcgui(cobolvar,$w)\n"
"				$w config -variable tc(check,$appl,$varname) \n"
"				set tc(offset,$appl,$varname) $tcgui(coboffset,$w)\n"
"			}\n"
"		}\n"
"	} elseif {$class == \"Image\"} {\n"
"		foreach at $tcgui(attrib,$class) {\n"
"			# standard tcl attributes\n"
"			if {[info exists tcgui(value,$w,$at)] &&\n"
"				$tcgui(value,$w,$at) != \"\" &&\n"
"				[lsearch $tcgui(tcl_attribs) $at]>=0} {\n"
"					$w config -$at $tcgui(value,$w,$at)\n"
"			} \n"
"		}\n"
"	} else {\n"
"		foreach at $tcgui(attrib,$class) {\n"
"			# standard tcl attributes\n"
"			if {[info exists tcgui(value,$w,$at)] &&\n"
"				$tcgui(value,$w,$at) != \"\" &&\n"
"				[lsearch $tcgui(tcl_attribs) $at]>=0} {\n"
"					$w config -$at $tcgui(value,$w,$at)\n"
"			} elseif {$at == \"label\" &&\n"
"				[info exists tcgui(value,$w,label)]} {\n"
"			# special label attribute for buttons, groups and labels\n"
"				$w config -text $tcgui(value,$w,$at)\n"
"			} \n"
"		}\n"
"	}\n"
"}\n"
"proc set_attribs {w args} {\n"
"	global tcgui\n"
"	foreach {at val} $args {\n"
"		set	tcgui(value,$w,$at) $val\n"
"	}\n"
"	apply_attrib $w\n"
"}\n"
"namespace eval base64 {\n"
"    variable i 0\n"
"    variable char\n"
"    variable base64\n"
"    variable base64_en\n"
"    foreach char {A B C D E F G H I J K L M N O P Q R S T U V W X Y Z \\\n"
"	      a b c d e f g h i j k l m n o p q r s t u v w x y z \\\n"
"	      0 1 2 3 4 5 6 7 8 9 + /} {\n"
"	set base64($char) $i\n"
"	set base64_en($i) $char\n"
"	incr i\n"
"    }\n"
"    namespace export *\n"
"}\n"
"proc base64::encode {args} {\n"
"    variable base64_en\n"
"    \n"
"    # Set the default wrapchar and maximum line length to match the output\n"
"    # of GNU uuencode 4.2.  Various RFC's allow for different wrapping \n"
"    # characters and wraplengths, so these may be overridden by command line\n"
"    # options.\n"
"    set wrapchar \"\\n\"\n"
"    set maxlen 60\n"
"    if { [llength $args] == 0 } {\n"
"	error \"wrong # args: should be \\\"[lindex [info level 0] 0]\\\n"
"		?-maxlen maxlen? ?-wrapchar wrapchar? string\\\"\"\n"
"    }\n"
"    set optionStrings [list \"-maxlen\" \"-wrapchar\"]\n"
"    for {set i 0} {$i < [llength $args] - 1} {incr i} {\n"
"	set arg [lindex $args $i]\n"
"	set index [lsearch -glob $optionStrings \"${arg}*\"]\n"
"	if { $index == -1 } {\n"
"	    error \"unknown option \\\"$arg\\\": must be -maxlen or -wrapchar\"\n"
"	}\n"
"	incr i\n"
"	if { $i >= [llength $args] - 1 } {\n"
"	    error \"value for \\\"$arg\\\" missing\"\n"
"	}\n"
"	set val [lindex $args $i]\n"
"	set [string range [lindex $optionStrings $index] 1 end] $val\n"
"    }\n"
"    \n"
"    if { ![string is integer -strict $maxlen] } {\n"
"	error \"expected integer but got \\\"$maxlen\\\"\"\n"
"    }\n"
"    set string [lindex $args end]\n"
"    set result {}\n"
"    set state 0\n"
"    set length 0\n"
"    foreach {c} [split $string {}] {\n"
"	# Do the line length check before appending so that we don't get an\n"
"	# extra newline if the output is a multiple of $maxlen chars long.\n"
"	if {$maxlen && $length >= $maxlen} {\n"
"	    append result $wrapchar\n"
"	    set length 0\n"
"	}\n"
"	scan $c %c x\n"
"	switch [incr state] {\n"
"	    1 {	append result $base64_en([expr {($x >>2) & 0x3F}]) }\n"
"	    2 { append result \\\n"
"		$base64_en([expr {(($old << 4) & 0x30) | (($x >> 4) & 0xF)}]) }\n"
"	    3 { append result \\\n"
"		$base64_en([expr {(($old << 2) & 0x3C) | (($x >> 6) & 0x3)}])\n"
"		append result $base64_en([expr {($x & 0x3F)}])\n"
"		incr length\n"
"		set state 0}\n"
"	}\n"
"	set old $x\n"
"	incr length\n"
"    }\n"
"    set x 0\n"
"    switch $state {\n"
"	0 { # OK }\n"
"	1 { append result $base64_en([expr {(($old << 4) & 0x30)}])== }\n"
"	2 { append result $base64_en([expr {(($old << 2) & 0x3C)}])=  }\n"
"    }\n"
"    return $result\n"
"}\n"
"proc base64::decode {string} {\n"
"    variable base64\n"
"    set output {}\n"
"    set group 0\n"
"    set j 18\n"
"    foreach char [split $string {}] {\n"
"	if {[string compare $char \"=\"]} {\n"
"	    # RFC 2045 says that line breaks and other characters not part\n"
"	    # of the Base64 alphabet must be ignored, and that the decoder\n"
"	    # can optionally emit a warning or reject the message.  We opt\n"
"	    # not to do so, but to just ignore the character.\n"
"	    if { ![info exists base64($char)] } {\n"
"		continue\n"
"	    }\n"
"	    set bits $base64($char)\n"
"	    set group [expr {$group | ($bits << $j)}]\n"
"	    if {[incr j -6] < 0} {\n"
"		scan [format %06x $group] %2x%2x%2x a b c\n"
"		append output [format %c%c%c $a $b $c]\n"
"		set group 0\n"
"		set j 18\n"
"	    }\n"
"	} else {\n"
"	    # = indicates end of data.  Output whatever chars are left.\n"
"	    # The encoding algorithm dictates that we can only have 1 or 2\n"
"	    # padding characters.  If j is 6, we have 12 bits of input \n"
"	    # (enough for 1 8-bit output).  If j is 0, we have 18 bits of\n"
"	    # input (enough for 2 8-bit outputs).\n"
"	    # It is crucial to scan three hex digits even though we\n"
"	    # discard c - older code used %04x and scanned 2 hex digits\n"
"	    # but really ended up generating 5 or 6 (not 4!) digits and\n"
"	    # resulted in alignment errors.\n"
"	    scan [format %06x $group] %2x%2x%2x a b c\n"
"	    if {$j == 6} {\n"
"		append output [format %c $a]\n"
"	    } elseif {$j == 0} {\n"
"		append output [format %c%c $a $b]\n"
"	    }\n"
"	    break\n"
"	}\n"
"    }\n"
"    return $output\n"
"}\n"
"namespace import base64::*\n"
"proc compare {s1 s2} {\n"
"    if {[string equal $s1 $s2]} {\n"
"	return equal\n"
"    }\n"
"    if {[string length $s1] != [string length $s2]} {\n"
"	return \"s1 length [string length $s1] != s2 length [string length $s2]\"\n"
"    }\n"
"    set i 0\n"
"    foreach c1 [split $s1 {}] c2 [split $s2 {}] {\n"
"	if {[string compare $c1 $c2] != 0} {\n"
"	    scan $c1 %c c1scanval\n"
"	    scan $c2 %c c2scanval\n"
"	    binary scan $c1 a c1binval\n"
"	    binary scan $c2 a c2binval\n"
"	    return \"char($i) c1 $c1 $c1scanval $c1binval c2 $c2 $c2scanval $c2binval\"\n"
"	}\n"
"	incr i\n"
"    }\n"
"}\n"
"proc exec_encoded {} {\n"
"	global encoded_source mainwin\n"
"	catch {file delete tmp.tcl.gz tmp.tcl}\n"
"	set f [open tmp.tcl.gz w]\n"
"	fconfigure $f -encoding binary -translation binary\n"
"	puts -nonewline $f [decode $encoded_source]\n"
"	close $f\n"
"	exec gunzip tmp.tcl.gz\n"
"	uplevel #0 source tmp.tcl\n"
"	catch {file delete tmp.tcl}\n"
"	flush stdout\n"
"}\n"
"set bmdata \"#define downbut_width 14\\n#define downbut_height 14\\n\"\n"
"append bmdata {static char downbut_bits[] = {\n"
"   0x00, 0x00, 0xe0, 0x01, 0xe0, 0x01, 0xe0, 0x01, 0xe0, 0x01, 0xfc, 0x0f,\n"
"   0xf8, 0x07, 0xf0, 0x03, 0xe0, 0x01, 0xc0, 0x00, 0x00, 0x00, 0xfe, 0x1f,\n"
"   0xfe, 0x1f, 0x00, 0x00};\n"
"}\n"
"image create bitmap comboboxbuttonimage -data $bmdata \n"
"bind ComboEntry <Double-1> {combobox_popup [winfo parent %W]}\n"
"bind ComboEntry <Down>   {combobox_popup [winfo parent %W]}\n"
"bind ComboEntry <Control-f>      {combobox_find  %W; break}\n"
"bind ComboEntry <Return>   {combobox_add   %W}\n"
"bind ComboList  <Escape>   {combobox_popup [winfo parent [winfo parent %W]]}\n"
"bind ComboList  <Double-1> {combobox_get   %W %y}\n"
"bind ComboList  <Return> {combobox_get   %W}\n"
"proc combobox {w args} {\n"
"    global comboboxbuttonimage\n"
"    if [winfo exists $w] { error \"window $w already exists\" }\n"
"    frame $w -class ComboBox\n"
"    ## Entry Widget, it gets all the args\n"
"    eval entry $w.e $args\n"
"    ## Button.  With the symbol font, it should be a down arrow\n"
"    button $w.b -image comboboxbuttonimage \\\n"
"	    -command [list combobox_popup $w]\n"
"    pack $w.b -side right -expand 0 -fill both \n"
"    pack $w.e -side left -fill both -expand 1\n"
"    ## Removable List Box\n"
"    toplevel $w.btm -cursor arrow\n"
"    wm withdraw $w.btm\n"
"    wm overrideredirect $w.btm 1\n"
"    wm transient $w.btm [winfo toplevel $w]\n"
"  \n"
"    listbox $w.btm.lbox -bd 2 -relief sunken -width 5 -height 5 \\\n"
"	    -yscrollcommand [list $w.btm.vs set] -selectmode browse \n"
"    scrollbar $w.btm.vs -width 10 -bd 1 -orient vertical \\\n"
"		-command [list $w.btm.lbox yview]\n"
"    pack $w.btm.lbox -side left -fill both -expand 1\n"
"    bindtags $w.e [linsert [bindtags $w.e] 1 ComboEntry]\n"
"    bindtags $w.btm.lbox [linsert [bindtags $w.btm.lbox] 1 ComboList]\n"
"    return $w\n"
"}\n"
"proc combobox_setlist {w args} {\n"
"    if {[winfo class $w] != \"ComboBox\"} {\n"
"	return -code error \"$w not a ComboBox\"\n"
"    }\n"
"    if [winfo ismapped $w.btm] {\n"
"	wm withdraw $w.btm\n"
"	$w.b configure -relief raised\n"
"    }\n"
"    $w.btm.lbox delete 0 end\n"
"    eval $w.btm.lbox insert end $args\n"
"}\n"
"proc combobox_getlist w {\n"
"    if {[winfo class $w] != \"ComboBox\"} {\n"
"	return -code error \"$w not a ComboBox\"\n"
"    }\n"
"    return [$w.btm.lbox get 0 end]\n"
"}    \n"
"proc combobox_popup w {\n"
"    if {[winfo class $w] != \"ComboBox\"} {\n"
"	return -code error \"$w not a ComboBox\"\n"
"    }\n"
"    if [winfo ismapped $w.btm] {\n"
"	wm withdraw $w.btm\n"
"	$w.b configure -relief raised\n"
"    } else {\n"
"	wm geometry $w.btm [winfo width $w.e]x[winfo reqheight $w.btm]+[winfo rootx $w]+[expr [winfo rooty $w]+[winfo reqheight $w]]\n"
"	if {[$w.btm.lbox size] > 5} {\n"
"	    pack $w.btm.vs -side right -fill y\n"
"	} elseif {[winfo manager $w.btm.vs] == \"pack\"} {\n"
"	    pack forget $w.btm.vs\n"
"	}\n"
"	wm deiconify $w.btm\n"
"	raise $w.btm\n"
"	$w.b configure -relief sunken\n"
"	focus $w.btm.lbox\n"
"    }\n"
"}\n"
"proc combobox_find W {\n"
"    set found 0\n"
"    set tmp [$W get]\n"
"    set lbox [winfo parent $W].btm.lbox\n"
"    foreach item [$lbox get 0 end] {\n"
"	if ![string first $tmp $item] {\n"
"	    incr found\n"
"	    set match $item\n"
"	}\n"
"    }\n"
"    switch $found {\n"
"	0 {}\n"
"	1 {\n"
"	    $W delete 0 end\n"
"	    $W insert end $match\n"
"	}\n"
"	default {\n"
"	    bell\n"
"	}\n"
"    }\n"
"}\n"
"proc combobox_add W {\n"
"    set i 1\n"
"    set tmp [$W get]\n"
"    foreach item [[winfo parent $W].btm.lbox get 0 end] {\n"
"	if ![string compare $item $tmp] {\n"
"	    set i 0\n"
"	    break\n"
"	}\n"
"    }\n"
"    if $i {\n"
"	[winfo parent $W].btm.lbox insert end $tmp\n"
"    }\n"
"    wm withdraw [winfo parent $W].btm\n"
"}\n"
"proc combobox_get {W {y \"\"}} {\n"
"    set e [winfo parent [winfo parent $W]].e\n"
"    if [$W size] {\n"
"	$e delete 0 end	\n"
"		if {$y != \"\"} {\n"
"			$e insert end [$W get [$W nearest $y]]\n"
"    	} else {\n"
"			if {[$W curselection] != \"\"} {\n"
"				$e insert end [$W get [$W curselection]]\n"
"			}\n"
"		}\n"
"	}\n"
"    wm withdraw [winfo parent $W]\n"
"    [winfo parent $e].b configure -relief raised\n"
"	focus $e\n"
"}\n"
};
